﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.Routing;

namespace Clib.Zone
{
    public class Zone
    {
        public static FeatureLayer Get()
        {

            var basepath = System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location.ToString()) + "\\data";
            var _r = basepath + @"\Zonelayer.shp";
            ShapeFileFeatureLayer layer = Route.Route.GetShapeFileLayer(_r);
            layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban2;
            return layer;
        }



        public static List<zoneInfoResponse> GetZoneInfoInRoute(RoutingResult route, FeatureLayer zoneFeatureLayer)
        {
            var _listZone = new List<zoneInfoResponse>();
            try
            {

                 var im = zoneFeatureLayer;
                im.Open();
                var _allLines = route.Route;
                var polygoncount = 0;
                var linecount = 0;




                foreach (Feature _zone in im.FeatureSource.GetAllFeatures(GetColumnsFromFeatureLayer(im)))
                {
                    var zo = new zoneInfoResponse();
                    polygoncount++;
                    //foreach (LineShape item in _allLines)
                    //{
                        linecount++;
                        var result = _allLines.GetIntersection(_zone);
                        if (result.Lines.Count() > 0)
                        {
                            var xx = result.Lines;
                            foreach (var item2 in xx)
                            {
                            
                                var zz = item2.GetLength(GeographyUnit.Meter, DistanceUnit.Kilometer);
                                //zo.zoneName = _zone
                                zo.zoneMeter += (item2.GetLength (GeographyUnit.Meter, DistanceUnit.Meter) * 100);
                            }

                        }
                    //}
                    if (zo.zoneMeter > 0)
                    {
                        _listZone.Add(zo);
                    }
                }
                im.Close();

                zoneFeatureLayer.Close();
            }
            catch (Exception ex)
            {
         //       doLog.ErrorException(ex.Message, ex);
                throw;
            }
            return _listZone;
        }

        public class zoneInfoResponse
        {
            public string zoneName { get; set; }
            public double zoneMeter { get; set; }
        }


        private static List<string> GetColumnsFromFeatureLayer(FeatureLayer im)
        {
            var allcolumns = im.FeatureSource.GetColumns();
            var columns = new List<string>();
            foreach (var item in allcolumns)
            {
                columns.Add(item.ColumnName);
            }
            return columns;
        }


    }
}
