﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using ThinkGeo.MapSuite.Routing;

namespace Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            var basepath = System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location.ToString()) + "\\data";
            Clib.Roads.Road.SetDkRoadsIndex(basepath + @"\sampledata.rtg");
            Clib.Roads.Road.SetDkRoads(basepath + @"\sampledata.shp");
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);
            FeatureLayer zones = Clib.Zone.Zone.Get();
            FeatureLayer roads = Clib.Roads.Road.Get();
            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("zonelayer", zones);
            staticOverlay.Layers.Add("roadlayer", roads);
            winformsMap1.Overlays.Add("overlayLayer", staticOverlay);
            LayerOverlay routingOverlay = new LayerOverlay();
            RoutingLayer routingLayer2 = new RoutingLayer();
            routingOverlay.Layers.Add("RoutingLayer", routingLayer2);
            winformsMap1.Overlays.Add("RoutingOverlay", routingOverlay);
            winformsMap1.CurrentExtent = new RectangleShape(11.96000d, 55.33000d, 11.97d, 55.32d);
            winformsMap1.Refresh(winformsMap1.Overlays["RoutingOverlay"]);
        }

        private void winformsMap1_MapClick(object sender, ThinkGeo.MapSuite.DesktopEdition.MapClickWinformsMapEventArgs e)
        {
            PointShape _pointshape = new PointShape();
            _pointshape.X = e.WorldX;
            _pointshape.Y = e.WorldY;
            PointShape _pointshapeEnd = new PointShape();
            var xend = 11.97228d;
            var yend = 55.33209d;
            _pointshapeEnd.X = xend;
            _pointshapeEnd.Y = yend;
            RoutingResult _route = Clib.Route.Route.GetRoute(_pointshape, _pointshapeEnd);
            AddRoute(Clib.Route.Route.GetRoute(_pointshape, _pointshapeEnd));
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PointShape _pointshape = new PointShape();
            _pointshape.X = 11.96758d;
            _pointshape.Y = 55.33060d;
            PointShape _pointshapeEnd = new PointShape();
            _pointshapeEnd.X = 11.96741d;
            _pointshapeEnd.Y = 55.33168d;
            AddRoute(Clib.Route.Route.GetRoute(_pointshape, _pointshapeEnd));
        }

        private void AddRoute(RoutingResult _route)
        {
            try
            {
                var _z = Clib.Zone.Zone.Get();
                RoutingLayer routingLayer = (RoutingLayer)((LayerOverlay)winformsMap1.Overlays["RoutingOverlay"]).Layers["RoutingLayer"];
                routingLayer.Routes.Clear();
                routingLayer.Routes.Add(_route.Route);
                winformsMap1.Refresh(winformsMap1.Overlays["RoutingOverlay"]);
            List<Clib.Zone.Zone.zoneInfoResponse> x = Clib.Zone.Zone.GetZoneInfoInRoute(_route, _z);    
                 textBox1.Text = String.Format("Route length: {0}", _route.Distance.ToString());
            textBox2.Text = String.Format("Meters in zone: {0}", x[0].zoneMeter);
            textBox3.Text = "Error - Diff: " + (_route.Distance - x[0].zoneMeter);
            }
            catch (Exception ex)
            {
                textBox1.Text = "Error";
                MessageBox.Show(String.Format("Error :{0}", ex.Message));
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
             PointShape _pointshape = new PointShape();
            _pointshape.X = 11.96758d;
            _pointshape.Y = 55.33060d;
            PointShape _pointshapeEnd = new PointShape();
            _pointshapeEnd.X = 11.96741d;
            _pointshapeEnd.Y = 55.33168d;

            
            var _route = Clib.Route.Route.GetRoute(_pointshape, _pointshapeEnd);
            
            AddRoute(_route);
           
        }
    }
}
